<!DOCTYPE html>
<html class="writer-html5" lang="en" >
<head>
  <meta charset="utf-8" /><meta name="generator" content="Docutils 0.18.1: http://docutils.sourceforge.net/" />

  <meta name="viewport" content="width=device-width, initial-scale=1.0" />
  <title>Pipe with a backward facing step &mdash; cflowpy Jule 2023 documentation</title>
      <link rel="stylesheet" href="../_static/pygments.css" type="text/css" />
      <link rel="stylesheet" href="../_static/css/theme.css" type="text/css" />
  <!--[if lt IE 9]>
    <script src="../_static/js/html5shiv.min.js"></script>
  <![endif]-->
  
        <script src="../_static/jquery.js"></script>
        <script src="../_static/_sphinx_javascript_frameworks_compat.js"></script>
        <script data-url_root="../" id="documentation_options" src="../_static/documentation_options.js"></script>
        <script src="../_static/doctools.js"></script>
        <script src="../_static/sphinx_highlight.js"></script>
        <script async="async" src="https://cdn.jsdelivr.net/npm/mathjax@3/es5/tex-mml-chtml.js"></script>
    <script src="../_static/js/theme.js"></script>
    <link rel="index" title="Index" href="../genindex.html" />
    <link rel="search" title="Search" href="../search.html" />
    <link rel="next" title="Cavity flow" href="cavity_flow.html" />
    <link rel="prev" title="Pipe flow" href="pipe_flow.html" /> 
</head>

<body class="wy-body-for-nav"> 
  <div class="wy-grid-for-nav">
    <nav data-toggle="wy-nav-shift" class="wy-nav-side">
      <div class="wy-side-scroll">
        <div class="wy-side-nav-search" >

          
          
          <a href="../index.html" class="icon icon-home">
            cflowpy
          </a>
<div role="search">
  <form id="rtd-search-form" class="wy-form" action="../search.html" method="get">
    <input type="text" name="q" placeholder="Search docs" aria-label="Search docs" />
    <input type="hidden" name="check_keywords" value="yes" />
    <input type="hidden" name="area" value="default" />
  </form>
</div>
        </div><div class="wy-menu wy-menu-vertical" data-spy="affix" role="navigation" aria-label="Navigation menu">
              <p class="caption" role="heading"><span class="caption-text">cflowpy:</span></p>
<ul class="current">
<li class="toctree-l1"><a class="reference internal" href="../installation.html">Installation</a></li>
<li class="toctree-l1"><a class="reference internal" href="../tutorial.html">Tutorial</a></li>
<li class="toctree-l1"><a class="reference internal" href="../grid.html">Grid</a></li>
<li class="toctree-l1 current"><a class="reference internal" href="../physical_problem.html">Physical Problem</a><ul class="current">
<li class="toctree-l2"><a class="reference internal" href="../physical_problem.html#constructor">Constructor</a></li>
<li class="toctree-l2"><a class="reference internal" href="../physical_problem.html#system-initialisation">System initialisation</a></li>
<li class="toctree-l2"><a class="reference internal" href="../physical_problem.html#boundary-conditions">Boundary Conditions</a></li>
<li class="toctree-l2 current"><a class="reference internal" href="../physical_problem.html#subclasses">Subclasses</a><ul class="current">
<li class="toctree-l3"><a class="reference internal" href="pipe_flow.html">Pipe flow</a></li>
<li class="toctree-l3"><a class="reference internal" href="pipe_flow.html#pressure-driven-pipe-flow">Pressure driven pipe flow</a></li>
<li class="toctree-l3 current"><a class="current reference internal" href="#">Pipe with a backward facing step</a><ul>
<li class="toctree-l4"><a class="reference internal" href="#constructor">Constructor</a></li>
<li class="toctree-l4"><a class="reference internal" href="#system-initialisation">System initialisation</a></li>
<li class="toctree-l4"><a class="reference internal" href="#boundary-conditions">Boundary Conditions</a></li>
<li class="toctree-l4"><a class="reference internal" href="#expected-results">Expected Results</a></li>
</ul>
</li>
<li class="toctree-l3"><a class="reference internal" href="cavity_flow.html">Cavity flow</a></li>
</ul>
</li>
</ul>
</li>
<li class="toctree-l1"><a class="reference internal" href="../integrator.html">Integrator</a></li>
<li class="toctree-l1"><a class="reference internal" href="../system.html">Solving the incompressible Navier-Stokes Equation</a></li>
</ul>

        </div>
      </div>
    </nav>

    <section data-toggle="wy-nav-shift" class="wy-nav-content-wrap"><nav class="wy-nav-top" aria-label="Mobile navigation menu" >
          <i data-toggle="wy-nav-top" class="fa fa-bars"></i>
          <a href="../index.html">cflowpy</a>
      </nav>

      <div class="wy-nav-content">
        <div class="rst-content">
          <div role="navigation" aria-label="Page navigation">
  <ul class="wy-breadcrumbs">
      <li><a href="../index.html" class="icon icon-home" aria-label="Home"></a></li>
          <li class="breadcrumb-item"><a href="../physical_problem.html">Physical Problem</a></li>
      <li class="breadcrumb-item active">Pipe with a backward facing step</li>
      <li class="wy-breadcrumbs-aside">
            <a href="../_sources/PhysicalProblems/pipe_with_a_backward_facing_step.rst.txt" rel="nofollow"> View page source</a>
      </li>
  </ul>
  <hr/>
</div>
          <div role="main" class="document" itemscope="itemscope" itemtype="http://schema.org/Article">
           <div itemprop="articleBody">
             
  <section id="pipe-with-a-backward-facing-step">
<h1>Pipe with a backward facing step<a class="headerlink" href="#pipe-with-a-backward-facing-step" title="Permalink to this heading"></a></h1>
<div class="line-block">
<div class="line">In this example our physical domain is a pipe, but with a backward facing step
at the left side of the domain.</div>
<div class="line">Vortexes are expected to build behind the step.</div>
</div>
<dl class="py class">
<dt class="sig sig-object py">
<em class="property"><span class="pre">class</span><span class="w"> </span></em><span class="sig-prename descclassname"><span class="pre">src.</span></span><span class="sig-name descname"><span class="pre">Pipe_with_a_backward_facing_step</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">x_step_End</span></span><span class="p"><span class="pre">:</span></span><span class="w"> </span><span class="n"><span class="pre">int</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">y_step_End</span></span><span class="p"><span class="pre">:</span></span><span class="w"> </span><span class="n"><span class="pre">int</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">u_left</span></span><span class="p"><span class="pre">:</span></span><span class="w"> </span><span class="n"><span class="pre">float</span></span></em><span class="sig-paren">)</span></dt>
<dd><p>This class is used to simulate a pipe with a backward facing step.</p>
<p>At the left edge of the domain there is used a
Dirichlet boundary condition, (velocity going into the pipe)
but only above the step.
In the step itself, the pressure and all velocities are set to zero.
All remaining boundary conditions stay the same as
for the “normal” pipe flow
This class extends “Pipe_flow”.</p>
<dl class="py attribute">
<dt class="sig sig-object py">
<span class="sig-name descname"><span class="pre">x_step_End</span></span></dt>
<dd><p>Index of the right edge of the step in the grid</p>
<dl class="field-list simple">
<dt class="field-odd">Type<span class="colon">:</span></dt>
<dd class="field-odd"><p>int</p>
</dd>
</dl>
</dd></dl>

<dl class="py attribute">
<dt class="sig sig-object py">
<span class="sig-name descname"><span class="pre">u_left</span></span></dt>
<dd><p>Velocity, in x-direction, at the left side
of the domain above the step</p>
<dl class="field-list simple">
<dt class="field-odd">Type<span class="colon">:</span></dt>
<dd class="field-odd"><p>float</p>
</dd>
</dl>
</dd></dl>

<dl class="py attribute">
<dt class="sig sig-object py">
<span class="sig-name descname"><span class="pre">y_step_End</span></span></dt>
<dd><p>Index of the top edge of the step in the grid</p>
<dl class="field-list simple">
<dt class="field-odd">Type<span class="colon">:</span></dt>
<dd class="field-odd"><p>int</p>
</dd>
</dl>
</dd></dl>

</dd></dl>

<section id="constructor">
<h2>Constructor<a class="headerlink" href="#constructor" title="Permalink to this heading"></a></h2>
<dl class="py method">
<dt class="sig sig-object py" id="src.Pipe_with_a_backward_facing_step.__init__">
<span class="sig-prename descclassname"><span class="pre">Pipe_with_a_backward_facing_step.</span></span><span class="sig-name descname"><span class="pre">__init__</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">x_step_End</span></span><span class="p"><span class="pre">:</span></span><span class="w"> </span><span class="n"><span class="pre">int</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">y_step_End</span></span><span class="p"><span class="pre">:</span></span><span class="w"> </span><span class="n"><span class="pre">int</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">u_left</span></span><span class="p"><span class="pre">:</span></span><span class="w"> </span><span class="n"><span class="pre">float</span></span></em><span class="sig-paren">)</span><a class="headerlink" href="#src.Pipe_with_a_backward_facing_step.__init__" title="Permalink to this definition"></a></dt>
<dd><p>Constructor</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters<span class="colon">:</span></dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>x_step_End</strong> (<em>int</em>) – Index for the end of the step in x-direction.
Be careful: This is just the index for the end of the step
in the vector, not the physically located end of the step.</p></li>
<li><p><strong>y_step_End</strong> (<em>int</em>) – Index for the end of the step in y-direction.
Be careful: This is just the index for the end of the step
in the vector, not the physically located end of the step.</p></li>
<li><p><strong>u_left</strong> (<em>float</em>) – Velocity in x-direction going from the left side into the domain.</p></li>
</ul>
</dd>
<dt class="field-even">Raises<span class="colon">:</span></dt>
<dd class="field-even"><ul class="simple">
<li><p><strong>TypeError</strong> – If either the x_step_End or y_step_End is no integer</p></li>
<li><p><strong>ValueError</strong> – If either x_step_end or y_step_end is smaller or equal 0</p></li>
<li><p><strong>TypeError</strong> – If u_left is no number</p></li>
</ul>
</dd>
</dl>
</dd></dl>

<div class="admonition warning">
<p class="admonition-title">Warning</p>
<blockquote>
<div><div class="line-block">
<div class="line">The arguments <code class="docutils literal notranslate"><span class="pre">x_end_step</span></code> and <code class="docutils literal notranslate"><span class="pre">y_end_step</span></code> define an <strong>array index</strong>
of the discretized domain, not the end of the physical domain.</div>
</div>
</div></blockquote>
<div class="admonition hint">
<p class="admonition-title">Hint</p>
<div class="line-block">
<div class="line">The number of Cells for each direction should be between
<span class="math notranslate nohighlight">\((x_n-x_0)\cdot 20 \leq n_i \leq (x_n-x_0)\cdot 50\)</span> where
<span class="math notranslate nohighlight">\(x_n\)</span> is the end of the domain, <span class="math notranslate nohighlight">\(x_0\)</span> the begin
of the domain and <span class="math notranslate nohighlight">\(n_i\)</span> the number of cells, for each dimension.</div>
<div class="line"><strong>Note:</strong> This might differ for some specific discretization like very
small or very large computational domains.</div>
<div class="line">Furthermore it is suggested to use a non-quadratic grid with, e.g.
<span class="math notranslate nohighlight">\(n_x = 3\cdot n_y\)</span>.</div>
</div>
</div>
</div>
<div class="line-block">
<div class="line"><strong>A small example</strong>:</div>
<div class="line">The x-direction goes from 0 to 10 with 100 grid points and
<code class="docutils literal notranslate"><span class="pre">x_end_step</span></code> is initialised with 7.</div>
<div class="line">In this case the step won’t stop at the x coordinate 7,
but at 0.7 since this is the seventh index of our discretized domain.</div>
<div class="line">It is possible to construct such a physical problem with the following:</div>
</div>
<div class="highlight-python notranslate"><div class="highlight"><pre><span></span><span class="gp">&gt;&gt;&gt; </span><span class="n">physical_problem</span> <span class="o">=</span> <span class="n">cf</span><span class="o">.</span><span class="n">Pipe_with_a_backward_facing_step</span><span class="p">(</span><span class="mi">7</span><span class="p">,</span> <span class="mi">1</span><span class="p">,</span> <span class="mi">7</span><span class="p">)</span>
</pre></div>
</div>
<div class="line-block">
<div class="line">In this case it is important how the physical domain is discretized.</div>
<div class="line">The physical domain has to have more points than the Indices for
<code class="docutils literal notranslate"><span class="pre">x_step_end</span></code> and <code class="docutils literal notranslate"><span class="pre">y_step_end</span></code>.</div>
<div class="line">This is not checked in the instantiation of
<code class="docutils literal notranslate"><span class="pre">Pipe_with_a_backward_facing_step</span></code> since the definition of the physical
problem is splitted from the definition of the grid itself.</div>
</div>
</section>
<section id="system-initialisation">
<h2>System initialisation<a class="headerlink" href="#system-initialisation" title="Permalink to this heading"></a></h2>
<div class="line-block">
<div class="line">The velocity in x-direction is initialized with <code class="docutils literal notranslate"><span class="pre">u_left</span></code>
everywhere, except in the step itself.</div>
<div class="line">The velocity in y-direction and the pressure are initialised to zero.</div>
</div>
<dl class="py method">
<dt class="sig sig-object py" id="src.Pipe_with_a_backward_facing_step.initialize_system">
<span class="sig-prename descclassname"><span class="pre">Pipe_with_a_backward_facing_step.</span></span><span class="sig-name descname"><span class="pre">initialize_system</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">u</span></span><span class="p"><span class="pre">:</span></span><span class="w"> </span><span class="n"><span class="pre">ndarray</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">v</span></span><span class="p"><span class="pre">:</span></span><span class="w"> </span><span class="n"><span class="pre">ndarray</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">p</span></span><span class="p"><span class="pre">:</span></span><span class="w"> </span><span class="n"><span class="pre">ndarray</span></span></em><span class="sig-paren">)</span><a class="headerlink" href="#src.Pipe_with_a_backward_facing_step.initialize_system" title="Permalink to this definition"></a></dt>
<dd><p>Initializes the start of the system.</p>
<p>In this case we want to start with the velocity in x-direction
beeing everywhere, except in the step, the value for u_left.
The velocity in y-direction and the pressure are not touched and
therefore are zero.</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters<span class="colon">:</span></dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>u</strong> (<em>np.ndarray</em>) – Velocity in x-direction</p></li>
<li><p><strong>v</strong> (<em>np.ndarray</em>) – Velocity in y-direction</p></li>
<li><p><strong>p</strong> (<em>np.ndarray</em>) – Pressure field</p></li>
</ul>
</dd>
<dt class="field-even">Raises<span class="colon">:</span></dt>
<dd class="field-even"><p><strong>TypeError</strong> – If one of the inputs is no numpy ndarray</p>
</dd>
<dt class="field-odd">Returns<span class="colon">:</span></dt>
<dd class="field-odd"><p>Initialized system</p>
</dd>
<dt class="field-even">Return type<span class="colon">:</span></dt>
<dd class="field-even"><p>np.ndarray, np.ndarray, np.ndarray</p>
</dd>
</dl>
</dd></dl>

</section>
<section id="boundary-conditions">
<h2>Boundary Conditions<a class="headerlink" href="#boundary-conditions" title="Permalink to this heading"></a></h2>
<div class="line-block">
<div class="line">As in <a class="reference internal" href="pipe_flow.html"><span class="doc">Pipe flow</span></a>, Dirichlet boundary conditions are used at the
left edge of the domain for the velocities.</div>
<div class="line">Neumann boundary conditions are used at the right side and the no-slip
condition is applied at the bottom and top edge.</div>
<div class="line">For the pressure there are used Neumann boundary conditions on each
side of the domain and the pressure inside the step
is set to zero in each iteration.</div>
</div>
<dl class="py method">
<dt class="sig sig-object py" id="src.Pipe_with_a_backward_facing_step.apply_bcs_velocity">
<span class="sig-prename descclassname"><span class="pre">Pipe_with_a_backward_facing_step.</span></span><span class="sig-name descname"><span class="pre">apply_bcs_velocity</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">u</span></span><span class="p"><span class="pre">:</span></span><span class="w"> </span><span class="n"><span class="pre">ndarray</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">v</span></span><span class="p"><span class="pre">:</span></span><span class="w"> </span><span class="n"><span class="pre">ndarray</span></span></em><span class="sig-paren">)</span><a class="headerlink" href="#src.Pipe_with_a_backward_facing_step.apply_bcs_velocity" title="Permalink to this definition"></a></dt>
<dd><p>Applies the boundary conditions for the velocity field.</p>
<p>Applies Dirichlet boundary conditoins on the left side of the domain
of the domain and above the step.
Everywhere als Neumann boundary conditions are applied
and inside the step all velocities are set to zero
:param u: velocity field in x-direction
:type u: np.ndarray
:param v: velocity field in y-direction
:type v: np.ndarray</p>
<dl class="field-list simple">
<dt class="field-odd">Raises<span class="colon">:</span></dt>
<dd class="field-odd"><p><strong>TypeError</strong> – If one of the inputs is no numpy ndarray</p>
</dd>
<dt class="field-even">Returns<span class="colon">:</span></dt>
<dd class="field-even"><p>Velocity fields after applying the boundary conditions</p>
</dd>
<dt class="field-odd">Return type<span class="colon">:</span></dt>
<dd class="field-odd"><p>np.ndarray, np.ndarray</p>
</dd>
</dl>
</dd></dl>

<dl class="py method">
<dt class="sig sig-object py" id="src.Pipe_with_a_backward_facing_step.apply_bcs_pressure">
<span class="sig-prename descclassname"><span class="pre">Pipe_with_a_backward_facing_step.</span></span><span class="sig-name descname"><span class="pre">apply_bcs_pressure</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">p</span></span><span class="p"><span class="pre">:</span></span><span class="w"> </span><span class="n"><span class="pre">ndarray</span></span></em><span class="sig-paren">)</span><a class="headerlink" href="#src.Pipe_with_a_backward_facing_step.apply_bcs_pressure" title="Permalink to this definition"></a></dt>
<dd><p>Applies the boundary conditions for the pressure field.</p>
<p>Applies Neumann boundary conditions on each side of the domain
In the step itself, the pressure is set to zero.</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters<span class="colon">:</span></dt>
<dd class="field-odd"><p><strong>p</strong> (<em>np.ndarray</em>) – pressure field</p>
</dd>
<dt class="field-even">Raises<span class="colon">:</span></dt>
<dd class="field-even"><p><strong>TypeError</strong> – If the pressure field is no numpy ndarray</p>
</dd>
<dt class="field-odd">Returns<span class="colon">:</span></dt>
<dd class="field-odd"><p>Pressure field after applying the boundary conditions</p>
</dd>
<dt class="field-even">Return type<span class="colon">:</span></dt>
<dd class="field-even"><p>np.ndarray</p>
</dd>
</dl>
</dd></dl>

</section>
<section id="expected-results">
<h2>Expected Results<a class="headerlink" href="#expected-results" title="Permalink to this heading"></a></h2>
<p>We expect two results occuring.
First, we would expect the <strong>Hagen-Poiseuille velocity</strong> profile before the step.
Additionally, at some distance behind the step we would expect a slightly shifted Hagen-Poiseuille velocity profile.
Furthermore, we expect <strong>vortexes</strong> immediately behind the step.
To get these results we can do the following:</p>
<div class="highlight-python notranslate"><div class="highlight"><pre><span></span><span class="gp">&gt;&gt;&gt; </span><span class="kn">import</span> <span class="nn">cflowpy</span> <span class="k">as</span> <span class="nn">cf</span>
<span class="gp">&gt;&gt;&gt; </span><span class="n">physical_problem_pipe_step</span> <span class="o">=</span> <span class="n">cf</span><span class="o">.</span><span class="n">Pipe_with_a_backward_facing_step</span><span class="p">(</span><span class="mi">60</span><span class="p">,</span> <span class="mi">20</span><span class="p">,</span> <span class="mi">5</span><span class="p">)</span>
<span class="gp">&gt;&gt;&gt; </span><span class="n">system_pipe_step</span> <span class="o">=</span> <span class="n">cf</span><span class="o">.</span><span class="n">System</span><span class="p">(</span><span class="mi">0</span><span class="p">,</span> <span class="mi">15</span><span class="p">,</span> <span class="mi">200</span><span class="p">,</span>
<span class="go">                                0, 5, 100,</span>
<span class="go">                                0.1, 1,</span>
<span class="go">                                physical_problem_pipe_step)</span>
<span class="gp">&gt;&gt;&gt; </span><span class="n">u</span><span class="p">,</span> <span class="n">v</span><span class="p">,</span> <span class="n">p</span> <span class="o">=</span> <span class="n">system_pipe_step</span><span class="o">.</span><span class="n">solve</span><span class="p">(</span><span class="mf">0.01</span><span class="p">,</span> <span class="mi">1</span><span class="p">,</span>
<span class="go">                                     n_iteration_pressure_poisson = 50,</span>
<span class="go">                                     adapt_dt = 0.5)</span>
</pre></div>
</div>
<div class="line-block">
<div class="line">To ensure numerical stability we use <code class="docutils literal notranslate"><span class="pre">adapt_dt</span></code> which adapts the time
step length if the cfl-condition is not fullfilled.</div>
<div class="line">To speed up the calculations we set the number of iteration in the
Poisson-Equation to 50 instead of the default value of 100.</div>
</div>
<div class="line-block">
<div class="line">And again we want to visualize our results:</div>
</div>
<dl class="simple">
<dt>fig = system_pipe_step.contourfigure(u, v, p,</dt><dd><p>contour=False, velocity=”streamline”,
velocity_profile = [20, 50, 100, 150],
title=”velocity profile of a pipe flow with a backward facing step”)</p>
</dd>
</dl>
<a class="reference internal image-reference" href="../_images/Pipe_step.png"><img alt="../_images/Pipe_step.png" src="../_images/Pipe_step.png" style="width: 600px;" /></a>
</section>
</section>


           </div>
          </div>
          <footer><div class="rst-footer-buttons" role="navigation" aria-label="Footer">
        <a href="pipe_flow.html" class="btn btn-neutral float-left" title="Pipe flow" accesskey="p" rel="prev"><span class="fa fa-arrow-circle-left" aria-hidden="true"></span> Previous</a>
        <a href="cavity_flow.html" class="btn btn-neutral float-right" title="Cavity flow" accesskey="n" rel="next">Next <span class="fa fa-arrow-circle-right" aria-hidden="true"></span></a>
    </div>

  <hr/>

  <div role="contentinfo">
    <p>&#169; Copyright 2023, Jan Habscheid.</p>
  </div>

  Built with <a href="https://www.sphinx-doc.org/">Sphinx</a> using a
    <a href="https://github.com/readthedocs/sphinx_rtd_theme">theme</a>
    provided by <a href="https://readthedocs.org">Read the Docs</a>.
   

</footer>
        </div>
      </div>
    </section>
  </div>
  <script>
      jQuery(function () {
          SphinxRtdTheme.Navigation.enable(true);
      });
  </script> 

</body>
</html>